/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include "cmsdk_debugtester.h"        // CMSIS Support for the debugtester
#include "system_cmsdk_debugtester.h" // CMSIS Support for the debugtester
#include "debugtester.h"              // Local header file
#include <stdio.h>                    // Access to printf
#ifdef DEBUGTESTER_BE
#define EXPECTED_BE 1
#else
#define EXPECTED_BE 0
#endif
struct {
  uint32_t stacktop;
  uint32_t traceconfigured;
} Cortex_MCU;
struct {
  uint32_t jtagnsw;
  uint32_t jtagapndp;
  uint32_t on;
  uint32_t banksel;
  uint32_t csw;
  uint32_t error;
  uint8_t  ack;
  uint8_t  stkerrclr;
} DAPSTATUS;
uint32_t trace_id = 0x71; // Init to reserved
uint32_t trace_errors = 0;
uint8_t  etm_packet[6];
uint32_t etm_bytes=0;
uint32_t etm_current=0;
uint32_t itm_current=0;
uint8_t  itm_header;
uint32_t itm_payload=0;
uint32_t itm_ts1=0;
uint32_t itm_ts2=0;
uint32_t itm_ts1_last=0;
uint32_t itm_bytes=0;
uint32_t itm_size=0;
uint32_t itm_ts=0;
uint32_t itm_sync=0;
uint32_t itm_overflow=0;
uint32_t itm_sw=0;
uint32_t itm_event=0;
uint32_t itm_periodic=0;
uint32_t itm_exception=0;
uint32_t itm_comp=0;
uint32_t itm_glb1=0;
uint32_t itm_glb2=0;
uint32_t current_address = 0;
uint32_t etm_ts1 = 0;
uint32_t etm_ts1_last = 0;
uint32_t etm_ts2 = 0;
uint32_t etm_p_headers =0;
uint32_t etm_i_sync =0;
uint32_t etm_branches =0;
uint32_t etm_exceptions =0;
uint32_t etm_rfe =0;
uint32_t etm_timestamps =0;
uint32_t etm_triggers =0;
uint32_t etm_ignore =0; // Expect 0
uint32_t fmt_triggers =0;
uint32_t fmt_frames =0;
uint32_t fmt_etm =0;
uint32_t fmt_itm =0;
uint32_t SWConnect(void);
uint32_t SWHeader(uint8_t);
uint32_t SWDataRead(void);
void     SWDataWrite(uint32_t);
void     SerialWireClockOut (uint32_t, uint32_t);
uint32_t SerialWireClockIn (uint32_t);
void     SWLineReset(uint8_t);
void     SWExitDormantState(void);
void     JTAGTransition(uint32_t, uint8_t);
uint64_t JTAGShift(uint64_t, uint8_t);
uint64_t JTAGScanIDCODE(void);
void     JTAGScanIR(uint32_t);
uint64_t JTAGScanDR(uint64_t);
uint32_t ParseTrace(uint8_t);
void     pulse_clock(uint8_t);
void     InitDAPSTATUS(void);
void     InitCommRegion(void);
uint32_t SwapEndian(uint32_t);
uint32_t ReadCommRegion(uint32_t);
void     WriteCommRegion(uint32_t, uint32_t);
uint32_t ReadMem(uint32_t);
uint32_t ReadMemH(uint32_t);
uint32_t ReadMemB(uint32_t);
void     ReadMemBlock(uint32_t, uint32_t, uint32_t *);
uint32_t ReadMemSpecial(uint32_t, uint8_t, uint32_t);
void     WriteMem(uint32_t, uint32_t);
void     WriteMemBlock(uint32_t, uint32_t, uint32_t *);
void     WriteMemH(uint32_t, uint32_t);
void     WriteMemB(uint32_t, uint32_t);
void     JtagAPnDP(uint32_t);
void     DPWriteBANKSEL(uint32_t);
void     DPWriteCTRLSTAT(uint32_t);
uint32_t DPReadCTRLSTAT(void);
uint32_t APReadCSW(void);
void     APWriteCSW(uint32_t);
void     APWriteTAR(uint32_t);
uint32_t APReadDRW(void);
void     APWriteDRW(uint32_t);
uint32_t DPReadRDBUFF(void);
uint32_t DPReadIDR(void);
uint32_t APReadIDR(void);
uint32_t APReadBASE(void);
uint32_t DPReadHALTEV(void);
void     DPClearSTICKYERR(void);
uint32_t CheckDAPSTATUS(void);
uint32_t SetInterfaceJTAG(void);
uint32_t SetInterfaceSW(void);
uint32_t DAPPowerUp(void);
uint32_t DAPPowerDown(void);
uint32_t GetTAPID(void);
uint32_t GetDPReg(void);
uint32_t GetAPReg(void);
uint32_t GetAPMem(void);
uint32_t SetAPMem(void);
uint32_t GetAPMemCSIDs(void);
uint32_t GetAPMemPID(void);
uint32_t ConnectWakeUnhalt(void);
uint32_t ConnectCheckUnlockup(void);
uint32_t EnableHaltingDebug(void);
uint32_t DAPAccess(void);
uint32_t ConfigTrace(void);
uint32_t CheckTrace(void);
uint32_t EmptyFunction(void);
uint32_t (*Func[]) (void) = { SetInterfaceJTAG,
			      SetInterfaceSW,
			      DAPPowerUp,
                              DAPPowerDown,
			      GetTAPID,
			      GetDPReg,
			      GetAPReg,
			      GetAPMem,
			      SetAPMem,
			      GetAPMemCSIDs,
			      ConnectWakeUnhalt,
			      ConnectCheckUnlockup,
                              EnableHaltingDebug,
			      DAPAccess,
			      ConfigTrace,
                              CheckTrace,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction,
			      EmptyFunction
};
int main (void)
{
  uint32_t SelectedFunction;
  GPIO0->DATAOUT = 0;
  GPIO0->OUTENABLESET = ( ((DD_IO_RUNNING | DD_IO_ERROR) << 8) |
		      (DD_DBG_TMSEN | DD_DBG_TMS | DD_DBG_TDI | DD_DBG_SWCLKTCK | DD_DBG_nTRST) );
  GPIO1->DATAOUT = 0;
  GPIO1->OUTENABLESET = ( DD_PRINT_STROBE | DD_PRINT_CHAR );
  GPIO0->DATAOUT = DD_DBG_nTRST;
  InitDAPSTATUS();
  Cortex_MCU.stacktop = 0;
  Cortex_MCU.traceconfigured = 0;
  while(1)
    {
      if(GPIO0->UB_MASKED[DD_IO_STROBE])
        {
	  GPIO0->UB_MASKED[DD_IO_ERROR] = 0;
	  SelectedFunction = (GPIO0->UB_MASKED[DD_IO_FUNCSEL]) >> 8;
	  GPIO0->UB_MASKED[DD_IO_RUNNING] = DD_IO_RUNNING << 8;
	  while(GPIO0->UB_MASKED[DD_IO_STROBE]);
          if( (*Func[SelectedFunction])() != 0 )
            {
	      GPIO0->UB_MASKED[DD_IO_ERROR] = DD_IO_ERROR << 8;
            };
	  GPIO0->UB_MASKED[DD_IO_RUNNING] = 0;
          DBG_MSG(("Selected function run finished, wait for new function\n"));
        }
    }
}
uint32_t SetInterfaceJTAG()
{
  DBG_MSG(("SetInterfaceJTAG()\n"));
  if(DAPSTATUS.on)
    {
      DBG_MSG(("SetInterfaceJTAG() TEST FAILED: DAP power on\n"));
      return TEST_FAIL;
    }
  else
    {
      DAPSTATUS.jtagnsw = 1;
      GPIO0->LB_MASKED[DD_DBG_TMSEN] = DD_DBG_TMSEN;
      JTAGTransition(0xff, 5);
      JTAGTransition(0, 1);
      return TEST_PASS;
    }
}
uint32_t SetInterfaceSW()
{
  DBG_MSG(("SetInterfaceSW()\n"));
  if(DAPSTATUS.on)
   {
     DBG_MSG(("SetInterfaceSW() TEST FAIL: DAP power on\n"));
     return TEST_FAIL;
   }
  else
    {
      DAPSTATUS.jtagnsw = 0;
      return SWConnect();
    }
}
uint32_t DAPPowerUp()
{
  DBG_MSG(("DAPPowerUp()\n"));
  if(DAPSTATUS.on == 0)
    {
      DPWriteCTRLSTAT( 0x50000000 );
      while((DPReadCTRLSTAT() & 0xF0000000UL) != 0xF0000000UL);
      DAPSTATUS.on=1;
      return CheckDAPSTATUS();
    }
  DBG_MSG(("DAPPowerUp() FAIL\n"));
  return TEST_FAIL;
}
uint32_t DAPPowerDown()
{
  uint32_t jtagnsw;
  uint32_t error;
  DBG_MSG(("DAPPowerDown()\n"));
  if(DAPSTATUS.on == 1)
    {
      DPWriteCTRLSTAT( 0x0 );
      while((DPReadCTRLSTAT() & 0xF0000000UL) != 0 );
      jtagnsw = DAPSTATUS.jtagnsw;
      error = DAPSTATUS.error;
      InitDAPSTATUS();
      DAPSTATUS.jtagnsw = jtagnsw;
      DAPSTATUS.error = error;
      return CheckDAPSTATUS();
    }
  DBG_MSG(("DAPPowerDown(): FAIL\n"));
  return TEST_FAIL;
}
uint32_t GetTAPID()
{
  DBG_MSG(("GetTAPID()\n"));
  InitCommRegion();
  if(DAPSTATUS.jtagnsw == 1)
    {
      WriteCommRegion(0, (JTAGScanIDCODE() & 0xFFFFFFFFUL) );
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t GetDPReg()
{
  uint32_t dpreg;
  uint32_t value;
  DBG_MSG(("GetDPReg()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      dpreg = ReadCommRegion(0);
      if(DAPSTATUS.jtagnsw)
	{
	  JtagAPnDP(DP);
	  JTAGScanDR(JTAG_SCAN(dpreg,READ));
	  value = DPReadRDBUFF();
	}
      else
	{
	  SWHeader(SW_HEADER(DP, READ, dpreg));
	  value = SWDataRead();
	}
      WriteCommRegion(0, value);
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t GetAPReg()
{
  uint32_t apreg;
  uint32_t value;
  DBG_MSG(("GetAPReg()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      apreg = ReadCommRegion(0);
      DPWriteBANKSEL( (apreg >> 4) & 0xF );
      if(DAPSTATUS.jtagnsw)
	{
	  JtagAPnDP(AP);
	  JTAGScanDR(JTAG_SCAN(apreg,READ));
	  value = DPReadRDBUFF();
	}
      else
	{
	  SWHeader( SW_HEADER(AP, READ, apreg) );
	  SWDataRead();
	  value = DPReadRDBUFF();
	}
      WriteCommRegion(0, value);
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t GetAPMem()
{
  uint32_t addr;
  uint32_t value;
  DBG_MSG(("GetAPMem()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      addr = ReadCommRegion(0);
      DBG_MSG(("GetAPMem(%x)\n",addr));
      value = ReadMem(addr);
      DBG_MSG(("GetAPMem(%x) returned %x\n", addr, value));
      WriteCommRegion(0, value);
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t SetAPMem()
{
  uint32_t addr;
  uint32_t value;
  DBG_MSG(("SetAPMem()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      addr = ReadCommRegion(0);
      value = ReadCommRegion(1);
      if(addr&0x3 == 0)
	{
	  WriteMem(addr, value);
	  return CheckDAPSTATUS();
	}
      DBG_MSG(("Only WORD writes are supported\n"));
    }
  return TEST_FAIL;
}
uint32_t GetAPMemCSIDs()
{
  uint32_t component_base;
  uint32_t csids[12];
  uint32_t cid;
  uint32_t pid_lo;
  uint32_t pid_hi;
  DBG_MSG(("GetAPMemCSIDs()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      component_base = ReadCommRegion(0);
      ReadMemBlock((component_base + PID4_OFFSET), 12, csids);
      pid_hi  =  (csids[0] & 0xFF);
      pid_hi |= ((csids[1] & 0xFF) << 8);
      pid_hi |= ((csids[2] & 0xFF) << 16);
      pid_hi |= ((csids[3] & 0xFF) << 24);
      pid_lo =   (csids[4] & 0xFF);
      pid_lo |= ((csids[5] & 0xFF) << 8);
      pid_lo |= ((csids[6] & 0xFF) << 16);
      pid_lo |= ((csids[7] & 0xFF) << 24);
      cid =   (csids[8] & 0xFF);
      cid |= ((csids[9] & 0xFF) << 8);
      cid |= ((csids[10] & 0xFF) << 16);
      cid |= ((csids[11] & 0xFF) << 24);
      WriteCommRegion(0, cid);
      WriteCommRegion(1, pid_lo);
      WriteCommRegion(2, pid_hi);
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t ConnectWakeUnhalt()
{
  uint32_t data;
  DBG_MSG(("ConnectWakeUnhalt()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      data=ReadMem(DHCSR_ADDR);
	if(data & S_SLEEP)
	  {
	    DBG_MSG(("Seen S_SLEEP\n"));
	    WriteMem(DHCSR_ADDR, (DBGKEY | C_HALT | C_DEBUGEN) );
	    DBG_MSG(("Written C_HALT\n"));
	    while((ReadMem(DHCSR_ADDR) & S_HALT) == 0);
	    DBG_MSG(("Seen S_HALT\n"));
	    WriteCommRegion(0, 1);
	    DBG_MSG(("Written flag\n"));
	    WriteMem(DHCSR_ADDR, DBGKEY);
	    DBG_MSG(("Cleared halt\n"));
	    return CheckDAPSTATUS();
	  }
	DBG_MSG(("Core not sleeping\n"));
	return TEST_FAIL;
    }
  return TEST_FAIL;
}
uint32_t EnableHaltingDebug()
{
  DBG_MSG(("EnableHaltingDebug()\n"));
  if(DAPSTATUS.on)
    {
      DBG_MSG(("EnableHaltingDebug()\n"));
      WriteMem(DHCSR_ADDR, (DBGKEY | C_DEBUGEN) );
      DBG_MSG(("Written C_DEBUGEN\n"));
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t ConnectCheckUnlockup()
{
  uint32_t value;
  DBG_MSG(("ConnectCheckUnlockup()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      if(ReadMem(DHCSR_ADDR) & S_LOCKUP)
	{
	  DBG_MSG(("Seen S_LOCKUP\n"));
	  WriteMem(DHCSR_ADDR, (DBGKEY | C_HALT | C_DEBUGEN) );
	  DBG_MSG(("Written C_HALT\n"));
	  while((ReadMem(DHCSR_ADDR) & S_HALT) == 0);
	  DBG_MSG(("Seen S_HALT\n"));
	  value = ReadCommRegion(2); // Reads from (Cortex_MCU.stacktop + 0x8)
	  WriteCommRegion(3, value); // Writes to (Cortex_MCU.stacktop + 0xC)
	  WriteMem(DCRSR_ADDR, (DebugReturnAddress));
	  while( (ReadMem(DHCSR_ADDR) & S_REGRDY) == 0 );
	  value = ReadMem(DCRDR_ADDR);
	  DBG_MSG(("Current DebugReturnAddress= %x\n", value));
	  value = (Cortex_MCU.stacktop + 0xC);
	  WriteMem(DCRDR_ADDR, value);
	  WriteMem(DCRSR_ADDR, (REGWnR | DebugReturnAddress));
	  while( (ReadMem(DHCSR_ADDR) & S_REGRDY) == 0 );
	  DBG_MSG(("Wrote return address= %x\n", value));
	  WriteMem(DHCSR_ADDR, DBGKEY);
	  DBG_MSG(("Cleared C_HALT\n"));
	  return CheckDAPSTATUS();
	}
      DBG_MSG(("Core not in lockup\n"));
      return TEST_FAIL;
    }
  return TEST_FAIL;
}
uint32_t DAPAccess()
{
  uint32_t retval = 0;
  DBG_MSG(("DAPAccess()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      WriteMem(Cortex_MCU.stacktop, 0);
      if(ReadMem(Cortex_MCU.stacktop) == 0)
	{
	  retval |= 0x1;
	  DBG_MSG(("Word was clear\n"));
	}
      WriteMemH((Cortex_MCU.stacktop + 2), 0x3456);
      if(ReadMem(Cortex_MCU.stacktop) == 0x34560000)
	{
	  retval |= 0x2;
	  DBG_MSG(("Read back correct value\n"));
	}
      else
	{
	  DBG_MSG(("Incorrect value - FAIL\n"));
	}
      WriteMemB((Cortex_MCU.stacktop + 1), 0x12);
      if(ReadMem(Cortex_MCU.stacktop) == 0x34561200)
	{
	  retval |= 0x4;
	  DBG_MSG(("Read back correct value\n"));
	}
      else
	{
	  DBG_MSG(("Incorrect value - FAIL\n"));
	}
      WriteCommRegion(0, retval);
      DBG_MSG(("Written retval: %x\n", retval));
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t ConfigTrace(void)
{
  DBG_MSG(("ConfigTrace()\n"));
  if(DAPSTATUS.on)
    {
      InitCommRegion();
      TRACE->CONFIG = ReadCommRegion(0); // Reads from (Cortex_MCU.stacktop);
      DBG_MSG(("TRACE->CONFIG= %x\n",TRACE->CONFIG));
      Cortex_MCU.traceconfigured = 1;
      return CheckDAPSTATUS();
    }
  return TEST_FAIL;
}
uint32_t CheckTrace(void)
{
  uint32_t i = 7;
  uint32_t frame_buffer[4];
  uint32_t lsb_bits;
  DBG_MSG(("CheckTrace()\n"));
  if(DAPSTATUS.on)
    {
      if(Cortex_MCU.traceconfigured == 0)
	{
	  DBG_MSG(("ERROR : ConfigTrace has not been ran before CheckTrace, or CheckTrace executed again without rerunning ConfigTrace\n"));
	  return TEST_FAIL;
	}
      else
	{
	  InitCommRegion();
	  Cortex_MCU.traceconfigured = 0;
	  DBG_MSG(("Trace Decompress\n"));
	  DBG_MSG(("initial i= %x, trace_errors=%x\n", i, trace_errors));
	  DBG_MSG(("initial TRACE->DEPTH = %x\n", TRACE->DEPTH));
	  DBG_MSG(("initial TRACE->STATUS = %x\n", TRACE->STATUS));
	  if ((TRACE->DEPTH ==0) &((TRACE->STATUS & 0x8)==0)) { //Trace depth is zero and no overflow
	    DBG_MSG(("No trace captured\n"));
	    return TEST_FAIL;
	  }
	  if ((TRACE->STATUS & 0x8)==0x8) { //Trace capture buffer overflow
	    DBG_MSG(("Trace capture buffer overflow\n"));
	    return TEST_FAIL;
	  }
	  DBG_MSG(("initial i= %x, trace_errors=%x\n", i, trace_errors));
	  while((i==7) && (trace_errors == 0))
	    {
	      DBG_MSG(("."));
	      for(i=0;i<4;i++)
		{
		  frame_buffer[i] = TRACE->DATA;
		  if (frame_buffer[i] == 0x7FFFFFFFUL)
		    {
		      if (i==0)
			{
			  DBG_MSG(("No more Frames\n"));
			  i=5;
			}
		      else
			{
			  DBG_MSG(("Incomplete Frame. At %d, %08x:%08x:%08x:%08x:\n",i,
				   frame_buffer[0],frame_buffer[1],frame_buffer[2],frame_buffer[3]));
			  i=5;
			  trace_errors++;
			}
		    }
		}
	      if(i==4)
		{
		  fmt_frames++;;
		  lsb_bits = frame_buffer[3] >> 24;
		  for(i=0;i<7;i++)
		    {
		      if((frame_buffer[i/2] & 0x1) == 0x1)
			{
			  if ((lsb_bits & 1) == 1)
			    {
			      ParseTrace(((frame_buffer[i/2]) >> 8) & 0xFF);
			      trace_id = (((frame_buffer[i/2]) >> 1) & 0x7F);
			    }
			  else
			    {
			      trace_id = (((frame_buffer[i/2]) >> 1) & 0x7F);
			      ParseTrace(((frame_buffer[i/2]) >> 8) & 0xFF);
			    }
			}
		      else
			{
			  ParseTrace((frame_buffer[i/2] & 0xFE) |
				     (lsb_bits & 1));
			  ParseTrace(((frame_buffer[i/2]) >> 8) & 0xFF);
			}
		      frame_buffer[i/2] = ((frame_buffer[i/2]) >> 16);
		      lsb_bits = lsb_bits >> 1;
		    }
		  if((frame_buffer[3] & 0x1) == 1)
		    {
		      if(lsb_bits != 0 )
			{
			  trace_errors ++;
			  DBG_MSG(("\nByte 14 is ID with LSB set, should be data\n"));
			}
		      else
			{
			  trace_id = ((frame_buffer[3] >> 1) & 0x7F);
			}
		    }
		  else
		    {
		      ParseTrace((frame_buffer[3] & 0xFE) | lsb_bits);
		    }
		}
	    }
	  DBG_MSG(("\nTrace extraction done, %d\n",trace_errors));
	  WriteCommRegion(0, ((fmt_triggers << 30) | (fmt_itm << 20) | (fmt_etm <<8) | fmt_frames) );
	  WriteCommRegion(1, (etm_p_headers | etm_i_sync <<14 | etm_branches<<20| etm_exceptions<<28));
	  WriteCommRegion(2, (etm_rfe | etm_timestamps<<4 | etm_ignore<<12 | etm_triggers <<14 |
			      itm_glb1 << 16 | itm_glb2 << 24 | itm_overflow <<28 | itm_sync << 2));
	  WriteCommRegion(3, (itm_ts<<27 | itm_sw<<22 | itm_event <<16 | itm_periodic <<11 | itm_exception <<6 | itm_comp));
	  return trace_errors;
	}
    }
  return TEST_FAIL;
}
uint32_t ParseTrace(uint8_t new_byte)
{
  switch (trace_id)
  {
    case 0:
      if(new_byte != 0)
      {
        DBG_MSG(("NULL ID (0) with non-zero data byte:%02x\n",new_byte));
        trace_errors++;
      }
      break;
  case MCU_ETM_ID:
      fmt_etm++;
      TRC_MSG(("%02x ",new_byte));
      switch (etm_current)
      {
        case 00:
          if(new_byte==0) // Sync Packet
          {
            etm_current = 1;
            etm_bytes++;
          }
          else if((new_byte & 1) ==1) // Branch Packet
          {
            current_address = (current_address & 0xFFFFFF80UL) |
              (new_byte & 0x7E);
            if((new_byte & 0x80)==0x80)
            {
              etm_current = 2;
              etm_packet[0] = new_byte;
              etm_bytes++;
            }
            else
            {
              TRC_MSG(("Branch to %08x\n",current_address));
              etm_branches++;
            }
          }
          else if(new_byte  ==0x08) // I-Sync packet
          {
            etm_current = 4;
          }
          else if(new_byte  ==0x0C) // Trigger, single byte
          {
            TRC_MSG(("ETM Trigger\n"));
            etm_triggers++;
          }
          else if(new_byte  ==0x66) // Ignore, single byte
          {
            TRC_MSG(("ETM Ignore byte\n"));
            etm_ignore++;
          }
          else if(new_byte  ==0x76) // RFE, single byte
          {
            TRC_MSG(("ETM Exception Return\n"));
            etm_rfe++;
          }
          else if((new_byte & 0x80 )== 0x80) // P-header, single byte
          {
            etm_p_headers++;
            TRC_MSG(("P-header, "));
            if((new_byte & 0x3) == 0) {
              if((new_byte & 0x3C) !=0) {
                TRC_MSG(("%d CC pass ",(new_byte & 0x3C)>>2));
              }
              if((new_byte & 0x40) !=0) {
                TRC_MSG(("1 CC Fail "));
              }
              TRC_MSG(("\n"));
            }
            else
            {
              if((new_byte & 0xF0) != 0x80)
              {
                DBG_MSG(("Bad P-Header\n"));
                trace_errors++;
              }
              etm_p_headers++;
              if((new_byte & 0x8) == 0x0)
              {
                TRC_MSG(("CC-Pass,"));
              }
              else
              {
                TRC_MSG(("CC-Fail,"));
              }
              if((new_byte & 0x4) == 0x0)
              {
                TRC_MSG(("CC-Pass\n"));
              }
              else
              {
                TRC_MSG(("CC-Fail\n"));
              }
            }
          }
          else if((new_byte | 0x04 )== 0x46) // Timestamp
          {
            etm_current = 8;
            etm_bytes=0;
            TRC_MSG(("ETM Timestamp, R-bit%d\n",(new_byte>>2) & 1));
            etm_timestamps++;
          }
          else
          {
            trace_errors++;
            DBG_MSG(("Bad ETM Byte\n"));
            TRC_MSG(("Header %02x Unknown\n",new_byte));
          }
          break;
        case 0x01: // Sync packet. 0x00 or 0x80
          if(new_byte==0)
          {
            etm_bytes++;
          }
          else if(new_byte==0x80)
          {
            etm_bytes=0;
            etm_current = 0;
            TRC_MSG(("Sync Packet\n"));
          }
          break;
        case 0x02: // Branch Packet. Uses continuation bits
          etm_packet[etm_bytes] = new_byte;
          etm_bytes++;
          if((new_byte >>7) == 0)
          {
            switch (etm_bytes)
            {
              case 2: // bits[12:7]
                current_address = (current_address & 0xFFFFD07F) | ((new_byte & 0x3E) << 6);
                break;
              case 3: // bits[19:14]
                current_address = (current_address & 0xFFF03FFF) | ((new_byte & 0x3E) << 13);
                break;
              case 4: // bits[26:21]
                current_address = (current_address & 0xF81FFFFF) | ((new_byte & 0x3E) << 20);
                break;
              case 5: // bits[31:28]
                trace_errors++;
                DBG_MSG(("Branch Packet Too long\n"));
                break;
            }
            TRC_MSG(("Branch Packet - Address %08x\n",current_address));
            etm_branches++;
            etm_bytes = 0;
            if((new_byte >>6) == 0)
            {
              etm_current = 0;
            }
            else
            {
              etm_current = 0x10;
            }
          }
          else
          {
            if(etm_bytes > 6) {
              DBG_MSG(("Branch Packet too long\n"));
              trace_errors++;
              switch (etm_bytes)
              {
                case 2: // bits[13:7]
                  current_address = (current_address & 0xFFFFC07F) | ((new_byte & 0x7E) << 6);
                  break;
                case 3: // bits[20:14]
                  current_address = (current_address & 0xFFE03FFF) | ((new_byte & 0x7E) << 13);
                  break;
                case 4: // bits[27:21]
                  current_address = (current_address & 0xF01FFFFF) | ((new_byte & 0x7E) << 20);
                  break;
                case 5: // bits[31:28]
                  current_address = (current_address & 0x0FFFFFFF) | ((new_byte & 0x7E) << 27);
                  break;
              }
            }
          }
          break;
        case 0x04: // I-sync packet. Fixed length for CM3-ETM / CM4-ETM
          etm_packet[etm_bytes] = new_byte;
          etm_bytes++;
          if(etm_bytes == 5)
          {
            current_address = (etm_packet[1] & 0xFE) |
              (etm_packet[2] << 8) | (etm_packet[3] << 16) | (etm_packet[4] << 24) ;
            if((etm_packet[0] & 0x9F) != 0x01)
            {
              trace_errors++;
              DBG_MSG(("Bad Isync information byte %02x\n",etm_packet[0]));
            }
            TRC_MSG(("I-Sync Packet "));
            switch(etm_packet[0]>>5 & 3)
            {
              case 0: TRC_MSG(("Periodic"));
                break;
              case 1: TRC_MSG(("Trc On"));
                break;
              case 2: TRC_MSG(("Overflow"));
                break;
              case 3: TRC_MSG(("Debug"));
            }
            TRC_MSG((", Address %08x\n",current_address));
            etm_i_sync++;
            etm_bytes = 0;
            etm_current = 0;
          }
          break;
        case 0x08: // Timestamp Packet
          etm_bytes++;
          switch (etm_bytes)
          {
            case 1:
              etm_ts1 = (etm_ts1 & 0xFFFFFF80UL) | (new_byte & 0x7F);
              break;
            case 2:
              etm_ts1 = (etm_ts1 & 0xFFFFC07FUL) | (new_byte & 0x7F)<<7;
              break;
            case 3:
              etm_ts1 = (etm_ts1 & 0xFFE03FFFUL) | (new_byte & 0x7F)<<14;
              break;
            case 4:
              etm_ts1 = (etm_ts1 & 0xF01FFFFFUL) | (new_byte & 0x7F)<<21;
              break;
            case 5:
              etm_ts1 = (etm_ts1 & 0x0FFFFFFFUL) | (new_byte & 0x0F)<<28;
              etm_ts2 = (etm_ts2 & 0xFFFFFFF8UL) | (new_byte & 0x70)>>4;
              break;
            case 6:
              etm_ts2 = (etm_ts2 & 0xFFFFFC07UL) | (new_byte & 0x7F)<<3;
              break;
            case 7:
              etm_ts2 = (etm_ts2 & 0xFFFF03FFUL) | (new_byte & 0x3F)<<10;
              if(new_byte & 0xC0 !=0)
              {
                DBG_MSG(("Last timestamp byte should have [7:6]=00\n"));
                trace_errors++;
                etm_current = 0;
              }
              break;
          }
          if((new_byte >> 7) ==0)
          {
            if ((etm_ts1 < etm_ts1_last) & etm_bytes <5)
            {
              DBG_MSG(("Timestamp must increase\n"));
              trace_errors++;
            }
            TRC_MSG(("ETM Timestamp %04x%08x\n",etm_ts2,etm_ts1));
            etm_current = 0;
            etm_bytes=0;
          }
          break;
        case 0x10: // Exception packet
          etm_bytes++;
          if((new_byte>>7) == 0)
          {
            etm_bytes=0;
            etm_current = 0;
            TRC_MSG(("Exception Taken\n"));
            etm_exceptions++;
          }
          else
          {
            if(etm_bytes > 2)
            {
              trace_errors++;
              DBG_MSG(("Exception packet too long\n"));
            }
          }
          break;
        default:
          DBG_MSG(("Trace parser crashed\n"));
          trace_errors++;
          break;
      }
      break;
  case MCU_ITM_ID:
      DBG_MSG(("ITM:%02x\n",new_byte));
      fmt_itm++;
      switch (itm_current)
      {
        case 0x00:
          if(new_byte == 00)
          {
            itm_current = 1;        // Sync
            itm_bytes=1;
          }
          else if(new_byte == 0x70) // Overflow
          {
            itm_overflow++;
            TRC_MSG(("ITM Overflow\n"));
          }
          else if((new_byte & 0x0F) == 0) // local timestamp
          {
            if ((new_byte & 0x80) == 0) // single byte TS
            {
              TRC_MSG(("ITM TS :%d\n",(new_byte & 0x70) >> 4));
              itm_ts++;
            }
            else
            {
              itm_current = 2;
              itm_header = new_byte;
              itm_payload = 0;
              itm_bytes=1;
            }
          }
          else if(new_byte == 0x94) // ts1
          {
            itm_current = 4;
            itm_header = new_byte;
            itm_payload = 0;
            itm_bytes=1;
          }
          else if(new_byte == 0xB4) // ts2
          {
            itm_current = 8;
            itm_header = new_byte;
            itm_payload = 0;
            itm_bytes=1;
          }
          else if((new_byte & 0x3) != 0)   // Stimulus packet
          {
            itm_current = 16;
            itm_header = new_byte;
            itm_payload = 0;
            itm_bytes=0;
            switch (new_byte & 0x3)
              {
              case 1: itm_size = 1;
                break;
              case 2: itm_size = 2;
                break;
              case 3: itm_size = 4;
                break;
              }
          }
          else
          {
            trace_errors++;
            DBG_MSG(("Un-recognised ITM\n"));
            TRC_MSG((" BAD Header %02x\n",new_byte));
          }
          break;
        case 0x01:
          itm_bytes ++;
          if(new_byte == 0x80)
          {
            TRC_MSG(("ITM Sync\n"));
            itm_sync++;
            itm_current = 0;
            itm_bytes = 0;
          }
          if((new_byte & 0x7F) != 0)
          {
            trace_errors++;
            itm_current = 0;
            itm_bytes = 0;
            DBG_MSG(("ITM Bad sync byte %02x\n",new_byte));
          }
          break;
        case 0x02:
          itm_payload = (itm_payload <<7) | (new_byte & 0x7F);
          if ((new_byte & 0x80) == 0)
          {
            switch (itm_header>>4 & 3)
            {
              case 0: TRC_MSG(("ITM TS delta:%d\n",itm_payload));
                break;
              case 1: TRC_MSG(("ITM Late TS :%d\n",itm_payload));
                break;
              case 2: TRC_MSG(("ITM TS for delayed packet :%d\n",itm_payload));
                break;
              case 3: TRC_MSG(("ITM late TS for delayed packet:%d\n",itm_payload));
                break;
            }
            itm_ts++;
            itm_current = 0;
            itm_bytes =0;
          }
          else
          {
            itm_bytes++;
            if (itm_bytes > 5)
            {
              trace_errors++;
              DBG_MSG(("ITM timestamp packet too long\n"));
              itm_current = 0;
              itm_bytes =0;
            }
          }
          break;
        case 0x04:
          switch (itm_bytes)
            {
            case 1:
              itm_ts1 = (itm_ts1 & 0xFFFFFF10) | (new_byte & 0x7f);
              break;
            case 2:
              itm_ts1 = (itm_ts1 & 0xFFFFC07F) | ((new_byte & 0x7f) <<7);
              break;
            case 3:
              itm_ts1 = (itm_ts1 & 0xFFF03FFF) | ((new_byte & 0x7f) <<14);
              break;
            case 4:
              itm_ts1 = (itm_ts1 & 0xFF10FFFF) | ((new_byte & 0x7f) <<21);
              break;
            }
          itm_bytes++;
          if((new_byte & 0x80) == 0x00)
          {
            TRC_MSG(("ITM Global TS1 :%d\n",itm_ts1 & 0x03FFFFFFUL));
            itm_glb1 ++;
            if(itm_ts1 > 0)
            {
              if((itm_ts1 < itm_ts1_last) & (new_byte & 0x40 == 0x00))
              {
                DBG_MSG(("Timestamp should increase"));
                trace_errors++;
              }
              itm_ts1_last = itm_ts1;
            }
            if (itm_bytes == 5)
            {
              if((new_byte & 0x20) == 0x20)
              {
                TRC_MSG(("ITM Global Clock Change\n"));
              }
              if((new_byte & 0x40) == 0x40)
              {
                TRC_MSG(("ITM Global low count bits wrapped\n"));
              }
            }
            itm_current = 0;
          }
          else
          {
            if (itm_bytes == 5)
            {
              DBG_MSG(("ITM TS1 too long\n"));
              trace_errors++;
              itm_current = 0;
              itm_bytes =0;
            }
          }
          break;
        case 0x08:
          switch (itm_bytes)
            {
            case 1:
              itm_ts2 = (itm_ts2 & 0xFFFFFF10) | (new_byte & 0x7f);
              break;
            case 2:
              itm_ts2 = (itm_ts2 & 0xFFFFC07F) | ((new_byte & 0x7f) <<7);
              break;
            case 3:
              itm_ts2 = (itm_ts2 & 0xFFF03FFF) | ((new_byte & 0x7f) <<14);
              break;
            case 4:
              itm_ts2 = (itm_ts2 & 0xFF10FFFF) | ((new_byte & 0x7f) <<21);
              break;
            }
          itm_bytes++;
          if((new_byte & 0x80) == 0x00)
          {
            TRC_MSG(("ITM Global TS2 :%d\n",itm_ts2 & 0x007FFFFFUL));
            itm_glb2 ++;
            if (itm_bytes == 5)
            {
              if(new_byte & 0xFE != 0x00)
              {
                DBG_MSG(("ITM TS2 byte 5 can only have bit[0] set\n"));
                trace_errors++;
              }
            }
            itm_current = 0;
          }
          else
          {
            if (itm_bytes == 5)
            {
              DBG_MSG(("ITM TS2 too long\n"));
              trace_errors++;
              itm_current = 0;
              itm_bytes =0;
            }
          }
          break;
        case 0x10:
          itm_payload = itm_payload | (new_byte << (itm_bytes * 8));
          itm_bytes ++;
          if(itm_bytes == itm_size)
          {
            if ((itm_header & 4) == 0)
            {
              TRC_MSG(("ITM s/w channel %d, %08x\n",itm_header>>3,itm_payload));
              itm_sw++;
            }
            else
            {
              switch(itm_header>>3)
                {
                case 0://Event packet
                  TRC_MSG(("ITM #"));
                  if((itm_payload & 1) == 1) {
                    TRC_MSG((" CPI"));
                    itm_event++;
                  }
                  if((itm_payload & 2) == 2) {
                    TRC_MSG((" Exc"));
                    itm_event++;
                  }
                  if((itm_payload & 4) == 4) {
                    TRC_MSG((" Sleep"));
                    itm_event++;
                  }
                  if((itm_payload & 8) == 8) {
                    TRC_MSG((" LSU"));
                    itm_event++;
                  }
                  if((itm_payload & 16) == 16) {
                    TRC_MSG((" FOLD"));
                    itm_event++;
                  }
                  if((itm_payload & 32) == 32) {
                    TRC_MSG((" Cyc"));
                    itm_event++;
                  }
                  TRC_MSG((" Event\n"));
                  break;
                case 1://Exception Packet
                  switch (itm_payload >> 12)
                    {
                    case 1:
                      TRC_MSG(("ITM Exception Entry %d\n",itm_payload & 0x1ff));
                      break;
                    case 2:
                      TRC_MSG(("ITM Exception Exit %d\n",itm_payload & 0x1ff));
                      break;
                    case 3:
                      TRC_MSG(("ITM Exception Return %d\n",itm_payload & 0x1ff));
                      break;
                    }
                  itm_exception++;
                  break;
                case 2:
                  if(itm_size == 4) {
                    TRC_MSG(("ITM PC periodic %08x\n",itm_payload));
                  } else {
                    TRC_MSG(("ITM PC periodic, sleeping\n"));
                  }
                  itm_periodic++;
                  break;
                default: // Other sources
                  if((itm_header & 0xC4) == 0x84){
                    TRC_MSG(("ITM Data Value %d:",(itm_header>> 4) & 3));
                    if ((itm_header & 8) == 0){
                      TRC_MSG(("Read "));
                    } else {
                      TRC_MSG(("Write "));
                    }
                    TRC_MSG((" %08x\n",itm_payload));
                  }
                  if((itm_header & 0xCF) == 0x47) {
                    TRC_MSG(("ITM Data PC %d:%08x\n",(itm_header>> 4) & 3,itm_payload));
                  }
                  if((itm_header & 0xCF) == 0x4E) {
                    TRC_MSG(("ITM Data Address offset %d:%08x\n",(itm_header>> 4) & 3,itm_payload));
                  }
                  if((itm_header >> 5) == 3) {
                    TRC_MSG(("ITM Unspecified HW source %d:%08x\n",(itm_header>> 3),itm_payload));
                    trace_errors++;
                  }
                  itm_comp++;
                }
            }
            itm_current = 0;
            itm_bytes =0;
          }
          break;
      }
      break;
    case 0x7D:
      if(new_byte != 0)
      {
        DBG_MSG(("Trigger with non-zero data byte:%02x\n",new_byte));
      }
      TRC_MSG(("Formatter Trigger\n"));
      fmt_triggers++;
      break;
    default:
      trace_errors ++;
      DBG_MSG(("Unexpected ID:%02x\n",trace_id));
      break;
  }
  return 0;
}
uint32_t EmptyFunction()
{
  DBG_MSG(("EmptyFunction()\n"));
  return TEST_FAIL;
}
void InitDAPSTATUS()
{
  DAPSTATUS.jtagnsw = 0;     // Serial Wire
  DAPSTATUS.jtagapndp = 2;   // Invalid value
  DAPSTATUS.on = 0;          // DAP powered off
  DAPSTATUS.banksel = 0xff;  // Invalid banksel value
  DAPSTATUS.csw = 0xffffffff;// Invalid CSW value - we haven't set up CSW
  DAPSTATUS.error = 0;       // No errors
  DAPSTATUS.ack = 0;         // Invalid value for ack
  DAPSTATUS.stkerrclr = 0;   // Not cleared
}
void InitCommRegion()
{
  if(Cortex_MCU.stacktop == 0)
    {
      DBG_MSG(("InitCommRegion()\n"));
      Cortex_MCU.stacktop = ReadMem(0);
      Cortex_MCU.stacktop = SwapEndian(Cortex_MCU.stacktop);
      DBG_MSG(("InitCommRegion() StackPointer = %x\n",Cortex_MCU.stacktop ));
    }
}
uint32_t SwapEndian(uint32_t data)
{
  if(EXPECTED_BE)
    {
      return __REV(data);
    }
  else
    {
      return data;
    }
}
uint32_t ReadCommRegion(uint32_t index)
{
  return SwapEndian( ReadMem( Cortex_MCU.stacktop + (4 * index)));
}
void WriteCommRegion(uint32_t index, uint32_t data)
{
  WriteMem( (Cortex_MCU.stacktop + (4 * index)), SwapEndian(data) );
}
uint32_t ReadMem(uint32_t address)
{
  uint32_t value;
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_WORD);
  APWriteTAR(address);
  APReadDRW();
  value = DPReadRDBUFF();
  DBG_MSG(("ReadMem(%x), returned: %x\n", address,value));
  return value;
}
uint32_t ReadMemH(uint32_t address)
{
  uint32_t value;
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_HALFWORD);
  APWriteTAR(address);
  APReadDRW();
  value = DPReadRDBUFF();
  DBG_MSG(("ReadMemH(%x), returned: %x\n", address,value));
  return value;
}
uint32_t ReadMemB(uint32_t address)
{
  uint32_t value;
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_BYTE);
  APWriteTAR(address);
  APReadDRW();
  value = DPReadRDBUFF();
  DBG_MSG(("ReadMemB(%x), returned: %x\n", address,value));
  return value;
}
void ReadMemBlock(uint32_t address, uint32_t numwords, uint32_t * data)
{
  uint32_t tar;
  uint32_t wordsread;
  DBG_MSG(("ReadMemBlock(%x, %x)\n",address, numwords));
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_SINGLE | CSW_SIZE_WORD);
  tar = address;
  APWriteTAR(tar);
  for(wordsread = 0; wordsread < numwords; wordsread++)
    {
      if(!(tar & 0x3FF))
        {
          APWriteTAR(tar);
        }
      if(wordsread)
	{
	  data[wordsread-1] = APReadDRW();
	}
      else
	{
	  APReadDRW();
	}
      tar += 4;
    }
  data[wordsread-1] = DPReadRDBUFF();
}
uint32_t ReadMemSpecial(uint32_t address, uint8_t size, uint32_t user)
{
  uint32_t value;
  uint32_t ctrlstat;
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_INCR_OFF | size | user);
  APWriteTAR(address);
  APReadDRW();
  value = DPReadRDBUFF();
  if(DAPSTATUS.jtagnsw)
    {
      ctrlstat = DPReadCTRLSTAT();
      if((ctrlstat >> 5) & 1UL)
        DAPSTATUS.error++;
    }
  if(DAPSTATUS.error == 1)
    {
      if(DAPSTATUS.jtagnsw)
        {
          DBG_MSG(("DAP access faulted, clearing sticky error bit\n"));
          DPClearSTICKYERR();
          DAPSTATUS.stkerrclr = 1;
        }
      else
        {
          ctrlstat = DPReadCTRLSTAT();
          if((ctrlstat >> 5) & 1UL)
            {
            DBG_MSG(("DAP access faulted, clearing sticky error bit\n"));
            DPClearSTICKYERR();
            DAPSTATUS.stkerrclr = 1;
            }
        }
     DAPSTATUS.error = 0;
    }
  else if(DAPSTATUS.error > 1)
         DBG_MSG(("More than one DAP error seen! Unexpected so not clearing sticky error bit\n"));
  DBG_MSG(("ReadMemSpecial(%x), returned: %x\n", address,value));
  return value;
}
void WriteMem(uint32_t address, uint32_t data)
{
  DBG_MSG(("WriteMem(%x, %x)\n",address, data));
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_WORD);
  APWriteTAR(address);
  APWriteDRW(data);
  DPReadRDBUFF();
}
void WriteMemBlock(uint32_t address, uint32_t numwords, uint32_t * data)
{
  uint32_t tar;
  uint32_t wordswritten;
  DBG_MSG(("WriteMemBlock(%x, %x, %x)\n",address, numwords, data));
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_SINGLE | CSW_SIZE_WORD);
  tar = address;
  APWriteTAR(tar);
  DBG_MSG(("Written 0x%x to TAR\n",tar));
  for(wordswritten = 0; wordswritten < numwords; wordswritten++)
    {
      if(!(tar & 0x3FF))
        {
          APWriteTAR(tar);
          DBG_MSG(("Written 0x%x to TAR\n",tar));
        }
      APWriteDRW(data[wordswritten]);
      tar += 4;
    }
  DPReadRDBUFF();
}
void WriteMemH(uint32_t address, uint32_t data)
{
  uint32_t ldata;
  ldata = data | (data << 16);
  DBG_MSG(("WriteMemH(%x, %x)\n",address, ldata));
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_HALFWORD);
  APWriteTAR(address);
  APWriteDRW(ldata);
  DPReadRDBUFF();
}
void WriteMemB(uint32_t address, uint32_t data)
{
  uint32_t ldata;
  ldata = data | (data << 8);
  ldata = ldata | (ldata << 16);
  DBG_MSG(("WriteMemB(%x, %x)\n",address, ldata));
  APWriteCSW(CSW_PROT_MASTER_DBG | CSW_PROT_PRIV | CSW_INCR_OFF | CSW_SIZE_BYTE);
  APWriteTAR(address);
  APWriteDRW(ldata);
  DPReadRDBUFF();
}
void JtagAPnDP(uint32_t apndp)
{
  if(DAPSTATUS.jtagapndp != apndp)
    {
      if(apndp)
      {
          JTAGScanIR(JTAG_APACC);
      }
      else
      {
          JTAGScanIR(JTAG_DPACC);
      }
      DAPSTATUS.jtagapndp = apndp;
    }
}
void DPWriteBANKSEL(uint32_t banksel)
{
  if(DAPSTATUS.banksel != banksel)
    {
      if(DAPSTATUS.jtagnsw)
      {
            JtagAPnDP(0);
            JTAGScanDR( (banksel << 7) | JTAG_SCAN(SELECT,WRITE) );
      }
      else
      {
            SWHeader( SW_HEADER(DP, WRITE, SELECT) );
            SWDataWrite( banksel << 4 );
      }
      DAPSTATUS.banksel = banksel;
    }
}
void DPWriteCTRLSTAT(uint32_t ctrlstat)
{
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(0);
      JTAGScanDR( (((uint64_t) ctrlstat) << 3) |  JTAG_SCAN(CTRLSTAT,WRITE)  );
    }
  else
    {
      SWHeader( SW_HEADER(DP, WRITE, CTRLSTAT) );
      SWDataWrite( ctrlstat );
    }
}
uint32_t DPReadCTRLSTAT()
{
  uint32_t data;
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(0);
      JTAGScanDR( JTAG_SCAN(CTRLSTAT,READ) );
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(DP, READ, CTRLSTAT) );
      data = SWDataRead();
    }
  return data;
}
uint32_t APReadCSW()
{
   uint32_t data;
  DPWriteBANKSEL(0UL << 4);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      JTAGScanDR( JTAG_SCAN(CSW, READ) );
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(AP, READ, CSW) );
      SWDataRead();
      data =DPReadRDBUFF();
    }
  return data;
}
void APWriteCSW(uint32_t csw)
{
  if(DAPSTATUS.csw != csw)
    {
      DPWriteBANKSEL(0UL << 4);
      if(DAPSTATUS.jtagnsw)
        {
          JtagAPnDP(1);
          JTAGScanDR( (((uint64_t) csw) << 3) |  JTAG_SCAN(CSW,WRITE) );
        }
      else
        {
          SWHeader( SW_HEADER(AP, WRITE, CSW) );
          SWDataWrite( csw );
        }
      DAPSTATUS.csw = csw;
    }
}
void APWriteTAR(uint32_t address)
{
  DPWriteBANKSEL(0UL << 4);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      JTAGScanDR( (((uint64_t) address) << 3) |  JTAG_SCAN(TAR,WRITE) );
    }
  else
    {
      SWHeader( SW_HEADER(AP, WRITE, TAR) );
      SWDataWrite( address );
    }
}
uint32_t APReadDRW()
{
  uint32_t data;
  DPWriteBANKSEL(0UL << 4);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      data = (JTAGScanDR(JTAG_SCAN(DRW,READ)) >> 3);
    }
  else
    {
      SWHeader( SW_HEADER(AP, READ, DRW) );
      data =  SWDataRead();
    }
  return data;
}
void APWriteDRW(uint32_t data)
{
  DPWriteBANKSEL(0UL << 4);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      JTAGScanDR( (((uint64_t) data) << 3) | JTAG_SCAN(DRW,WRITE) );
    }
  else
    {
      SWHeader( SW_HEADER(AP, WRITE, DRW) );
      SWDataWrite(data);
    }
}
uint32_t DPReadRDBUFF()
{
  uint32_t data;
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(0);
      data = ( JTAGScanDR(JTAG_SCAN(RDBUFF,READ)) >> 3);
    }
  else
    {
      SWHeader( SW_HEADER(DP, READ, RDBUFF) );
      data = SWDataRead();
    }
  return data;
}
uint32_t DPReadIDR()
{
  uint32_t data;
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(0);
      JTAGScanDR(JTAG_SCAN(DPIDR,READ));
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(DP, READ, DPIDR) );
      data = SWDataRead();
    }
  return data;
}
uint32_t APReadIDR()
{
  uint32_t data;
  DPWriteBANKSEL(0xF);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      JTAGScanDR(JTAG_SCAN(IDR,READ));
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(AP, READ, IDR) );
      SWDataRead();
      data = DPReadRDBUFF();
    }
  return data;
}
uint32_t APReadBASE()
{
  uint32_t data;
  DPWriteBANKSEL(0xF);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(1);
      JTAGScanDR(JTAG_SCAN(BASE,READ));
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(AP, READ, BASE) );
      SWDataRead();
      data =DPReadRDBUFF();
    }
  return data;
}
uint32_t DPReadHALTEV()
{
  uint32_t data;
  DPWriteBANKSEL(0x4UL);
  if(DAPSTATUS.jtagnsw)
    {
      JtagAPnDP(0);
      JTAGScanDR(JTAG_SCAN(HALTEV,READ));
      data = DPReadRDBUFF();
    }
  else
    {
      SWHeader( SW_HEADER(DP, READ, HALTEV));
      data = SWDataRead();
    }
  DPWriteBANKSEL(0x0UL);
  return data;
}
void DPClearSTICKYERR()
{
  uint32_t ctrlstat;
  if(DAPSTATUS.jtagnsw)
    {
#ifdef CORTEX_M0PLUS
      ctrlstat = (1UL << 5) | (5UL << 28);
#else
      ctrlstat = (1UL << 5);
#endif
      JtagAPnDP(0);
      JTAGScanDR( (((uint64_t) ctrlstat) << 3) |  JTAG_SCAN(CTRLSTAT,WRITE)  );
    }
  else
    {
      SWHeader( SW_HEADER(DP, WRITE, ABORT) );
#ifdef CORTEX_M0PLUS
      SWDataWrite( 1UL << 2 );
#else
      SWDataWrite( 1UL << 5 );
#endif
    }
}
uint32_t CheckDAPSTATUS()
{
  if(DAPSTATUS.jtagnsw)
    {
      if((DPReadCTRLSTAT() >> 5) & 1UL)
        DAPSTATUS.error++;
    }
  if(DAPSTATUS.error != 0)
    {
      DBG_MSG(("Errors found in Debugger accesses -\tFAIL\n"));
      return TEST_FAIL;
    }
  return TEST_PASS;
}
void pulse_clock(uint8_t number_of_clock_ticks)
{
  uint8_t count;
  for(count = number_of_clock_ticks; count > 0; count--)
    {
      GPIO0->LB_MASKED[DD_DBG_SWCLKTCK] = DD_DBG_SWCLKTCK;
      GPIO0->LB_MASKED[DD_DBG_SWCLKTCK] = 0;
    }
}
uint64_t JTAGScanIDCODE()
{
  uint64_t tmp;
  JTAGScanIR(JTAG_IDCODE);
  JTAGTransition(0x1, 3);
  tmp = JTAGShift(0, 32);
  JTAGTransition(0x1, 2);
  return tmp;
}
void JTAGScanIR(uint32_t instruction)
{
  JTAGTransition(0x3, 4);
  JTAGShift(instruction, 4);
  JTAGTransition(0x1, 2);
}
uint64_t JTAGScanDR(uint64_t data)
{
  uint64_t tmp;
  uint8_t ack;
  do
  {
    JTAGTransition(0x1, 3);
    tmp = JTAGShift(data, 35);
    JTAGTransition(0x1, 2);
    ack = (uint8_t)tmp & 7UL;
    DAPSTATUS.ack = ack;
  } while (ack == JTAG_DP_ACK_WAIT);
  return tmp;
}
void JTAGTransition(uint32_t tms, uint8_t numbits)
{
  uint8_t i;
  for(i = numbits; i > 0; i--)
    {
      if(tms & 0x1)
        {
	  GPIO0->LB_MASKED[DD_DBG_TMS] = DD_DBG_TMS;
        }
      else
        {
	  GPIO0->LB_MASKED[DD_DBG_TMS] = 0;
        }
      tms = (tms >> 1);
      pulse_clock(1);
    }
}
uint64_t JTAGShift(uint64_t data, uint8_t numbits)
{
  uint8_t i;
  uint64_t captured_data = 0;
  GPIO0->LB_MASKED[DD_DBG_TMS] = 0;
  for(i = numbits; i > 0; i--)
    {
      if(data & 0x1)
        {
	  GPIO0->LB_MASKED[DD_DBG_TDI] = DD_DBG_TDI;
        }
      else
        {
	  GPIO0->LB_MASKED[DD_DBG_TDI] = 0;
        }
      data = (data >> 1);
      captured_data = captured_data >> 1;
      if(GPIO0->LB_MASKED[DD_DBG_TDO])
        {
           captured_data |= (0x1ull << 63);
        }
      if(i == 1)
        {
	  GPIO0->LB_MASKED[DD_DBG_TMS] = DD_DBG_TMS;
        }
      pulse_clock(1);
    }
  captured_data = captured_data >> (64-numbits);
  return captured_data;
}
uint32_t SWConnect()
{
  uint32_t tmp;
#ifdef SWJ_DEPRECATED_SWITCHING_SEQUENCE
  SWLineReset(0);
  SerialWireClockOut(0xE79E,16);
#endif
#ifdef SWMD_TARGET_SELECTION
  SWExitDormantState();
  SWHeader( SW_HEADER(DP, WRITE, TARGETSEL));
  DAPSTATUS.ack = SW_DP_ACK_OK;
  SWDataWrite( MCU_TARGETSEL_VALUE );
#endif
  SWLineReset(8);
  SWHeader( SW_HEADER(DP,READ,DPIDR) );
  tmp = SWDataRead();
  DBG_MSG(("SWConnect returned DPIDR: %x\n", tmp));
  return CheckDAPSTATUS();
}
void SWDataWrite(uint32_t data)
{
  uint32_t mask;
  uint32_t parity;
  pulse_clock(1);
  if(DAPSTATUS.ack == SW_DP_ACK_OK)
    {
      SerialWireClockOut(data,32);
      for(parity=0, mask=0x1; mask != 0; mask = mask << 1)
        {
          parity += (data & mask) ? 1 : 0;
        }
      SerialWireClockOut(parity,1);
    }
}
uint32_t SWDataRead(void)
{
   uint32_t rdata;
  if(DAPSTATUS.ack == SW_DP_ACK_OK)
    {
      rdata = SerialWireClockIn(32);
      SerialWireClockIn(2);
    }
  else
    {
      pulse_clock(1);
      rdata = 0xDEADBEEFUL;
    }
  DBG_MSG(("SWDataRead() returned %x\n", rdata));
  return rdata;
}
uint32_t SWHeader(uint8_t header)
{
  uint32_t ack;
  do {
  SerialWireClockOut(header, 8);
  ack = SerialWireClockIn(4);
  ack = (ack >> (32 - 3)) & 0x7;
  if (ack == SW_DP_ACK_FAULT)
    DAPSTATUS.error++;
  if (ack == SW_DP_ACK_WAIT)
      SerialWireClockOut(0UL,1);
    DAPSTATUS.ack = ack;
  } while (ack == SW_DP_ACK_WAIT);
  if (ack != SW_DP_ACK_OK)
    {
      DBG_MSG(("ERROR - Maybe unhandled SW-DP response "));
      switch(ack)
	{
	case SW_DP_ACK_WAIT:
	  DBG_MSG(("WAIT\n"));
	  break;
	case SW_DP_ACK_FAULT:
	  DBG_MSG(("ERROR\n"));
	  break;
	default:
	  DBG_MSG(("Unknown, %x\n",ack));
	  break;
	}
    }
  return ack;
}
void SerialWireClockOut (uint32_t data, uint32_t numbits)
{
  GPIO0->LB_MASKED[DD_DBG_TMSEN] = DD_DBG_TMSEN;
  for(; numbits > 0; numbits--)
    {
      if(data & 0x1)
        {
	  GPIO0->LB_MASKED[DD_DBG_TMS] = DD_DBG_TMS;
        }
      else
        {
	  GPIO0->LB_MASKED[DD_DBG_TMS] = 0;
        }
      pulse_clock(1);
      data = (data >> 1);
    }
}
uint32_t SerialWireClockIn (uint32_t numbits)
{
  uint32_t data = 0;
  GPIO0->LB_MASKED[DD_DBG_TMSEN] = 0;
  for(; numbits > 0; numbits--)
    {
      data = (data >> 1);
      if(GPIO0->LB_MASKED[DD_DBG_TMSIN])
        {
          data |= (0x1UL << 31);
        }
      pulse_clock(1);
    }
  return data;
}
void SWLineReset(uint8_t num_of_idle_cycles)
{
  GPIO0->LB_MASKED[DD_DBG_SWCLKTCK] = 0;
  GPIO0->LB_MASKED[(DD_DBG_TMS | DD_DBG_TMSEN)] = (DD_DBG_TMS | DD_DBG_TMSEN);
  pulse_clock(50);
  GPIO0->LB_MASKED[DD_DBG_TMS] = 0;
  pulse_clock(num_of_idle_cycles);
}
void SWExitDormantState(void)
{
  DBG_MSG(("Leaving Dormant State\n"));
  SerialWireClockOut(0xFFUL,8);
  SerialWireClockOut(DS_to_SWD_0,32);
  SerialWireClockOut(DS_to_SWD_1,32);
  SerialWireClockOut(DS_to_SWD_2,32);
  SerialWireClockOut(DS_to_SWD_3,32);
  SerialWireClockOut(0UL,4);
  SerialWireClockOut(SW_ACTV_CODE,8);
  SWLineReset(2);
}

