/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include "SPI.h"
#include "STC33Fxxx_gpio.h"
#include "STC33Fxxx_rcc.h"

__IO uint8_t aRxBuffer [100];
__IO uint8_t ubRxIndex;
__IO uint8_t ubTxIndex = 0;

uint8_t aTxBuffer[100];
uint8_t SPI2ubTxBuffer[100];
__IO uint8_t SPI2aRxBuffer [100];

__IO uint32_t TimeOut = 0;
__IO uint8_t SPI2ubRxIndex = 0;

void SPI1_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    SPI_InitTypeDef  SPI_InitStructure;

    /* Peripheral Clock Enable -------------------------------------------------*/
    /* Enable the SPI clock */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
    /* Enable GPIO clocks */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);    //ʹGPIOAʱ

    // PA4=SPI1_NSS      PA5=SPI1_SCK      PA6=SPI1_MISO     PA7=SPI1_MOSI
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
    GPIO_InitStructure.GPIO_PuPd  =   GPIO_PuPd_UP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);  

//    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;       //SPI1_NSS IO(SPI_NSS = SPI_NSS_Soft)
//    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
//    GPIO_Init(GPIOA, &GPIO_InitStructure);  
    
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource4, GPIO_AF_SPI1);  //PA4Ϊ SPI1_NSS
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource5, GPIO_AF_SPI1);  //PA5Ϊ SPI1_CLK
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource6, GPIO_AF_SPI1);  //PA6Ϊ SPI1_MISO
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_SPI1);  //PA7Ϊ SPI1_MOSI

    RCC_APB2PeriphResetCmd(RCC_APB2Periph_SPI1,ENABLE);      //λSPI1
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_SPI1,DISABLE);     //ֹͣλSPI1
    /* SPI configuration -------------------------------------------------------*/
    SPI_I2S_DeInit(SPI1);
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);

    SPI_SSOutputCmd(SPI1, ENABLE);  //ʹӲSS (SPI_NSS = SPI_NSS_Hard)
//    SPI_CalculateCRC(SPI1, ENABLE); //ʹCRC
//    SPI_TIModeCmd(SPI1, ENABLE);    //DISABLE: Motorola Mode, ENABLE: TI mode

    /* Configure the Priority Group to 1 bit */                
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);

    /* Configure the SPI interrupt priority */
    NVIC_InitStructure.NVIC_IRQChannel = SPI1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    /* Enable the Rx buffer not empty interrupt */
//    SPI_I2S_ITConfig(SPI1, SPI_I2S_IT_RXNE, ENABLE);

    /* Enable the Tx buffer empty interrupt */
//    SPI_I2S_ITConfig(SPI1, SPI_I2S_IT_TXE, ENABLE);

    /* Enable the SPI peripheral */
    SPI_Cmd(SPI1, ENABLE);
}

void SPI2_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    SPI_InitTypeDef  SPI_InitStructure;

    /* Peripheral Clock Enable -------------------------------------------------*/
    /* Enable the SPI clock */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
    /* Enable GPIO clocks */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);           //ʹGPIOBʱ

    // PB12=SPI2_NSS  PB13=SPI2_SCK  PB14=SPI2_MISO  PB15=SPI2_MOSI
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15; //PB12~15ù	
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;                    //ù
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;                  //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;              //100MHz
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;                    //
    GPIO_Init(GPIOB, &GPIO_InitStructure);                          //ʼIO

    GPIO_PinAFConfig(GPIOB,GPIO_PinSource12,GPIO_AF_SPI2);           //PB12Ϊ SPI2_NSS
    GPIO_PinAFConfig(GPIOB,GPIO_PinSource13,GPIO_AF_SPI2);           //PB13Ϊ SPI2_SCK
    GPIO_PinAFConfig(GPIOB,GPIO_PinSource14,GPIO_AF_SPI2);           //PB14Ϊ SPI2_MISO
    GPIO_PinAFConfig(GPIOB,GPIO_PinSource15,GPIO_AF_SPI2);           //PB15Ϊ SPI2_MOSI


    RCC_APB1PeriphResetCmd(RCC_APB1Periph_SPI2,ENABLE);      //λSPI
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_SPI2,DISABLE);     //ֹͣλSPI
    /* SPI configuration -------------------------------------------------------*/
    SPI_I2S_DeInit(SPI2);
    SPI_InitStructure.SPI_Mode = SPI_Mode_Slave;
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI2, &SPI_InitStructure);

//    SPI_SSOutputCmd(SPI2, ENABLE);  //ʹӲSS (SPI_NSS = SPI_NSS_Hard)
//    SPI_CalculateCRC(SPI2, ENABLE); //ʹCRC
//    SPI_TIModeCmd(SPI2, ENABLE);    //DISABLE: Motorola Mode, ENABLE: TI mode

    /* Configure the Priority Group to 1 bit */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);

    /* Configure the SPI interrupt priority */
    NVIC_InitStructure.NVIC_IRQChannel = SPI2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);


    /* The Data transfer is performed in the SPI interrupt routine */

    /* Enable the Rx buffer not empty interrupt */
    SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_RXNE, ENABLE);

    /* Enable the Tx empty interrupt */
    //SPI_I2S_ITConfig(SPI2, SPI_I2S_IT_TXE, ENABLE);

    /* Enable the SPI peripheral */
    SPI_Cmd(SPI2, ENABLE);
}

void SPI3_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    SPI_InitTypeDef  SPI_InitStructure;

    /* Peripheral Clock Enable -------------------------------------------------*/
    /* Enable the SPI clock */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);
    /* Enable GPIO clocks */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);           //ʹGPIOAʱ
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);           //ʹGPIOBʱ
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);           //ʹGPIOCʱ

    // PA15=SPI3_NSS  PB3=SPI3_SCK  PB4=SPI3_MISO  PB5=SPI3_MOSI
//    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5; //PB3~5ù	
    // PA15=SPI3_NSS  PC10=SPI3_SCK  PC11=SPI3_MISO  PC12=SPI3_MOSI
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12; //PC10~12ù	
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;                    //ù
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;                  //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;              //100MHz
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;                    //
//    GPIO_Init(GPIOB, &GPIO_InitStructure);                          //ʼIO
    GPIO_Init(GPIOC, &GPIO_InitStructure);                          //ʼIO

    // PA15=SPI3_NSS  PC10=SPI3_SCK  PC11=SPI3_MISO  PC12=SPI3_MOSI
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;  //PA15ù	
    GPIO_Init(GPIOA, &GPIO_InitStructure);                          //ʼIO
    
//    GPIO_PinAFConfig(GPIOA,GPIO_PinSource15,GPIO_AF_SPI3);           //PA15Ϊ SPI3_NSS
//    GPIO_PinAFConfig(GPIOB,GPIO_PinSource3,GPIO_AF_SPI3);            //PB3Ϊ SPI3_SCK
//    GPIO_PinAFConfig(GPIOB,GPIO_PinSource4,GPIO_AF_SPI3);            //PB4Ϊ SPI3_MISO
//    GPIO_PinAFConfig(GPIOB,GPIO_PinSource5,GPIO_AF_SPI3);            //PB5Ϊ SPI3_MOSI

    GPIO_PinAFConfig(GPIOA,GPIO_PinSource15,GPIO_AF_SPI3);           //PA15Ϊ SPI3_NSS
    GPIO_PinAFConfig(GPIOC,GPIO_PinSource10,GPIO_AF_SPI3);           //PC10Ϊ SPI3_SCK
    GPIO_PinAFConfig(GPIOC,GPIO_PinSource11,GPIO_AF_SPI3);           //PC11Ϊ SPI3_MISO
    GPIO_PinAFConfig(GPIOC,GPIO_PinSource12,GPIO_AF_SPI3);           //PC12Ϊ SPI3_MOSI

    RCC_APB1PeriphResetCmd(RCC_APB1Periph_SPI3,ENABLE);      //λSPI
    RCC_APB1PeriphResetCmd(RCC_APB1Periph_SPI3,DISABLE);     //ֹͣλSPI
    /* SPI configuration -------------------------------------------------------*/
    SPI_I2S_DeInit(SPI3);
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI3, &SPI_InitStructure);

    SPI_SSOutputCmd(SPI3, ENABLE);  //ʹӲSS (SPI_NSS = SPI_NSS_Hard)
//    SPI_CalculateCRC(SPI3, ENABLE); //ʹCRC
//    SPI_TIModeCmd(SPI3, ENABLE);    //DISABLE: Motorola Mode, ENABLE: TI mode

    /* Configure the Priority Group to 1 bit */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);

    /* Configure the SPI interrupt priority */
    NVIC_InitStructure.NVIC_IRQChannel = SPI3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);


    /* The Data transfer is performed in the SPI interrupt routine */

    /* Enable the Rx buffer not empty interrupt */
//    SPI_I2S_ITConfig(SPI3, SPI_I2S_IT_RXNE, ENABLE);

    /* Enable the Tx empty interrupt */
    //SPI_I2S_ITConfig(SPI3, SPI_I2S_IT_TXE, ENABLE);

    /* Enable the SPI peripheral */
    SPI_Cmd(SPI3, ENABLE);
}

extern __IO uint8_t ubTxIndex;
extern __IO uint8_t SPI2ubRxIndex;
extern uint8_t aTxBuffer[];
//extern uint8_t M_RxOK;
void SPI_SendBuffer(SPI_TypeDef* SPIx, uint8_t *pData, uint16_t Size)
{
    ubTxIndex = 0;
    ubRxIndex = 0;
    SPI2ubRxIndex = 0;
    /* Enable the Rx buffer not empty interrupt */
    SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_RXNE, ENABLE);
    /* Enable the Tx empty interrupt */
    SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_TXE, ENABLE); //TXEжϣжݷ(ͻΪջһֱжϣֱд뷢ݻ߹رշж)

/*
//	uint16_t i;

	for(i=0;i<Size;i++)
	{
        SPI_I2S_SendData(SPIx, pData[i]);     //дݲTXE־
//        while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);
//        SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_TXE);

        while(M_RxOK==0);
        M_RxOK = 0;

//        while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
//        SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_RXNE);
//        aRxBuffer[ubRxIndex++] = SPI_I2S_ReceiveData(SPIx);     //ȡݲRXNE־
	}

    SPI_TransmitCRC(SPIx);  //SET CRCNEXT
    SPI_I2S_SendData(SPIx, pData[i]);     //дݲTXE־
    while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);
//    SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_TXE);

    while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
//    SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_RXNE);
    aRxBuffer[ubRxIndex++] = SPI_I2S_ReceiveData(SPIx);     //ȡݲRXNE־
*/
//    /* Disable the Tx buffer empty interrupt */
//    SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_TXE, DISABLE);
//    /* Disable the Rx buffer not empty interrupt */
//    SPI_I2S_ITConfig(SPIx, SPI_I2S_IT_RXNE, DISABLE);
    
/*
	for(i=0;i<Size-1;)
	{
//		if (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == SET)
		{
//			SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_TXE);
			SPI_I2S_SendData(SPIx, pData[i++]);
            while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);
			SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_TXE);

            while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
            SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_RXNE);
            aRxBuffer[ubRxIndex++] = SPI_I2S_ReceiveData(SPIx);
		}
	}

    SPI_TransmitCRC(SPIx);  //SET CRCNEXT
//		while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET){};
		{
			SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_TXE);
			SPI_I2S_SendData(SPIx, pData[i++]);

            while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
            SPI_I2S_ClearFlag(SPIx, SPI_I2S_FLAG_RXNE);
            aRxBuffer[ubRxIndex++] = SPI_I2S_ReceiveData(SPIx);
		}
    
//    aRxBuffer[ubRxIndex++] = SPI_GetCRC(SPI1,SPI_CRC_Rx);
*/
}
