/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/
 
#include "stc_rtc.h"
#include "string.h"
#include "stdlib.h"  

#define LSI

u8 day_flag;
u8 hour_flag;
u8 min_flag;
u8 sec_flag;
u8 sec2_flag;
u8 sec8_flag;
u8 sec32_flag;
u8 alr_flag;

void MRTC_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec, u8 ssec);
void MRTC_SetAlr(u8 hour, u8 min, u8 sec, u8 ssec);
void MRTC_ITConfig(u16 RTC_IT, FunctionalState NewState);
void MRTC_ClearFlag(u16 RTC_FLAG);
void MRTC_Cmd(FunctionalState NewState);

void EXTIX_Init(uint32_t EXTIX_Line)
{
	EXTI_InitTypeDef EXTI_InitStructure;
	EXTI_InitStructure.EXTI_Line = EXTIX_Line;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;	 //ѡЧ
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;		         //ʹܸͨж
	EXTI_Init(&EXTI_InitStructure);
}

void RTC_NVIC_Config(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_InitStructure.NVIC_IRQChannel = RTC_Alarm_IRQn;		//RTCȫж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 01;	//ռȼ1λ,ȼ3λ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 03;	        //ռȼ0λ,ȼ4λ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;		        //ʹܸͨж
	NVIC_Init(&NVIC_InitStructure);		                        //NVIC_InitStructָĲʼNVICĴ
}

void stc_rtc_init(void)
{
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR,ENABLE);
    
    PWR->CR |= PWR_CR_DBP;  //enable DBP
    MRTC->WRP = 0xca;       // RTC д
    MRTC->WRP = 0x53;    
    
#ifdef LSI
	RCC->CSR |= 0x01;
	RCC_RTCCLKConfig(RCC_RTCCLKSource_LSI);		//RTCʱ(RTCCLK),ѡLSIΪRTCʱ
	RCC->BDCR |= 0x8000;
#else
	RCC_LSEConfig(RCC_LSE_ON);	//ⲿپ(LSE),ʹپ
	RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);		//RTCʱ(RTCCLK),ѡLSEΪRTCʱ
	RCC->BDCR |= 0x8001;
#endif

    RCC->CFGR &= ~0x1000;   //no divider for apb1 clock

    MRTC_Set(24, 2, 29, 23, 59, 55, 0);
    MRTC_SetAlr(23,59,56,0);
    
    MRTC_ClearFlag(0xffff);
    MRTC_ITConfig(MRTC_IT_ALR, ENABLE);
//    MRTC_ITConfig(MRTC_IT_DAY, ENABLE); //DAYжϵĻDAYжϺRTCʧЧ
    MRTC_ITConfig(MRTC_IT_HOU, ENABLE);
    MRTC_ITConfig(MRTC_IT_MIN, ENABLE);
    MRTC_ITConfig(MRTC_IT_SEC, ENABLE);
    MRTC_ITConfig(MRTC_IT_SEC2, ENABLE);
    MRTC_ITConfig(MRTC_IT_SEC8, ENABLE);
    MRTC_ITConfig(MRTC_IT_SEC32, ENABLE);

    EXTIX_Init(EXTI_Line17);    //RTCжEXTIжҪʹ EXTI_Line17
    RTC_NVIC_Config();

	MRTC_Cmd(ENABLE);
}

void MRTC_ITConfig(uint16_t RTC_IT, FunctionalState NewState)
{
	if (NewState != DISABLE)
	{
		MRTC->RTCIEN |= (uint16_t)RTC_IT;
	}
	else
	{
		MRTC->RTCIEN &= (uint16_t)~RTC_IT;
	}
}

void MRTC_Cmd(FunctionalState NewState)
{
	if (NewState != DISABLE)
	{
		MRTC->RTCCR = 1;
	}
	else
	{
		MRTC->RTCCR = 0;
	}
}

void MRTC_ClearITPendingBit(uint16_t RTC_IT)
{
	MRTC->RTCIF &= (uint16_t)~RTC_IT;
}

void MRTC_ClearFlag(uint16_t RTC_FLAG)
{
	MRTC->RTCIF &= (uint16_t)~RTC_FLAG;
}

ITStatus MRTC_GetITStatus(uint32_t RTC_IT)
{
  ITStatus bitstatus = RESET;
  bitstatus = (ITStatus)(MRTC->RTCIF & RTC_IT);
  if (bitstatus != (uint32_t)RESET)
  {
    bitstatus = SET;
  }
  else
  {
    bitstatus = RESET;
  }
  return bitstatus;
}

void MRTC_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec, u8 ssec)
{
    MRTC->INIYEAR = syear;
    MRTC->INIMONTH = smon;
    MRTC->INIDAY = sday;
    MRTC->INIHOUR = hour;
    MRTC->INIMIN = min;
    MRTC->INISEC = sec;
    MRTC->INISSEC = ssec;
    MRTC->RTCCFG = 1;
}

void MRTC_SetAlr(u8 hour, u8 min, u8 sec, u8 ssec)
{
    MRTC->ALAHOUR = hour;
    MRTC->ALAMIN = min;
    MRTC->ALASEC = sec;
    MRTC->ALASSEC = ssec;
}

void MRTC_Get(void)
{
    printf("20%d-%d-%d %d:%d:%d\r\n", MRTC->YEAR,MRTC->MONTH,MRTC->DAY,MRTC->HOUR,MRTC->MIN,MRTC->SEC);
}

void RTC_Alarm_IRQHandler()
{
    EXTI_ClearFlag(EXTI_Line17);
	if(MRTC_GetITStatus(MRTC_IT_ALR)!=RESET)//жϼ־
	{
        alr_flag = 1;
        MRTC_SetAlr(0,0,10,0);
        MRTC_ClearITPendingBit(MRTC_IT_ALR);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_DAY)!=RESET)//жϼ־
	{
        day_flag = 1;
        MRTC_ClearITPendingBit(MRTC_IT_DAY);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_HOU)!=RESET)//жϼ־
	{
        hour_flag = 1;
        MRTC_ClearITPendingBit(MRTC_IT_HOU);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_MIN)!=RESET)//жϼ־
	{
        min_flag = 1;
        MRTC_ClearITPendingBit(MRTC_IT_MIN);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_SEC)!=RESET)//жϼ־
	{
        sec_flag = 1;
        GPIO_ToggleBits(GPIOA,GPIO_Pin_1);  //жжǷ
        MRTC_ClearITPendingBit(MRTC_IT_SEC);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_SEC2)!=RESET)//жϼ־
	{
        sec2_flag = 1;
        MRTC_ClearITPendingBit(MRTC_IT_SEC2);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_SEC8)!=RESET)//жϼ־
	{
        sec8_flag = 1;
        MRTC_ClearITPendingBit(MRTC_IT_SEC8);//жϱ־
	}

	if(MRTC_GetITStatus(MRTC_IT_SEC32)!=RESET)//жϼ־
	{
        sec32_flag = 1;
        GPIO_ToggleBits(GPIOA,GPIO_Pin_0);  //жжǷ
        MRTC_ClearITPendingBit(MRTC_IT_SEC32);//жϱ־
	}
}
