/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/
 
#include "usart2.h"
#include "string.h"
#include "stdlib.h"  

u8 Lin_Sending_Flag;
u8 Lin_Reception_of_data;
u8 Lin_LBD_Flag;

u8 Lin_Read_Len;

LinTx_TypeDef linTxMsg;
LinRx_TypeDef linRxMsg;

void init_LIN(void)
{
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1ENR_USART2EN,ENABLE);
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);    //ʹGPIOAʱ

    //PA2=LIN_TX     PA3=LIN_RX
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2 | GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);  

    GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_USART2);  //PA2Ϊ USART2_TX
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource3, GPIO_AF_USART2);  //PA3Ϊ USART2_RX
	
	USART_InitStructure.USART_BaudRate = 9600;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART2, &USART_InitStructure);
	
	USART_LINBreakDetectLengthConfig(USART2,USART_LINBreakDetectLength_11b);
	USART_LINCmd(USART2,ENABLE);
	
	USART_ClearFlag(USART2,USART_FLAG_LBD);
	
	USART_ITConfig(USART2,USART_IT_RXNE,ENABLE);
	USART_ITConfig(USART2,USART_IT_LBD,ENABLE);
	
	NVIC_InitStructure.NVIC_IRQChannel=USART2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority=0;
	NVIC_InitStructure.NVIC_IRQChannelCmd=ENABLE;
	NVIC_Init(&NVIC_InitStructure);	
	
	USART_Cmd(USART2,ENABLE);
	
	//ʼ
	linTxMsg.Send_Complete=ENABLE;
	linRxMsg.Length=8;
    linRxMsg.Index=0;
    
    linTxMsg.ID = 0x23;
    linTxMsg.Length = 8;
    linTxMsg.Data[0] = 0x11;
    linTxMsg.Data[1] = 0x22;
    linTxMsg.Data[2] = 0x33;
    linTxMsg.Data[3] = 0x14;
    linTxMsg.Data[4] = 0x15;
    linTxMsg.Data[5] = 0x16;
    linTxMsg.Data[6] = 0x17;
    linTxMsg.Data[7] = 0x18;
}

u8 lin_Check_ProtectedID(u16 id)//УPID
{
	u8 checkSum=id&0x3f;
	checkSum|=(((checkSum&0x01)^((checkSum&0x02)>>1)^((checkSum&0x04)>>2)^((checkSum&0x10)>>4))<<6)&0x40;
	checkSum|=(~((((checkSum&0x02)>>1)^((checkSum&0x08)>>3)^((checkSum&0x10)>>4)^((checkSum&0x20)>>5))<<7))&0x80;
	return checkSum;
}

void Lin_Send_Header(u16 id)
{
    linTxMsg.Protected_ID = lin_Check_ProtectedID(id);//УPID
    while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
    USART_SendBreak(USART2);//ͬʱ
    while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
    USART_SendData(USART2,0x55);//ͬ
    while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
    USART_SendData(USART2,linTxMsg.Protected_ID);//PID
//    linRxMsg.Receive_Complete = DISABLE;

    while(!linRxMsg.Receive_Complete){};
    linRxMsg.Receive_Complete = DISABLE;

    printf("len=%d, Read:\r\n",Lin_Read_Len);
    for(u8 i=0; i<Lin_Read_Len-1; i++)    printf("%02x ", linRxMsg.Data[i]);
    printf("\r\n");
}

void Lin_Send_Msg()
{
	Lin_Sending_Flag=ENABLE;
	linTxMsg.Protected_ID = lin_Check_ProtectedID(linTxMsg.ID);//УPID
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
	USART_SendBreak(USART2);//ͬʱ
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
	USART_SendData(USART2,0x55);//ͬ
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ݼĴձ־
	USART_SendData(USART2,linTxMsg.Protected_ID);//PID
	for (u8 i = 0; i < linTxMsg.Length; i++) 
	{
		while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//
		USART_SendData(USART2,linTxMsg.Data[i]);    
		linTxMsg.CheckSum += linTxMsg.Data[i];       //У
		if (linTxMsg.CheckSum >= 256)
			linTxMsg.CheckSum = (linTxMsg.CheckSum+1)&0xff;
	}
	linTxMsg.CheckSum=(u8)~linTxMsg.CheckSum;
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//У
	USART_SendData(USART2,linTxMsg.CheckSum);
	while(USART_GetFlagStatus(USART2,USART_FLAG_TXE)==RESET);//ȴͽ
	linTxMsg.CheckSum=0;
	Lin_Sending_Flag=DISABLE;
}

void Lin_Data_receiving_callback()//Linջص
{
	if(Lin_Reception_of_data==1)
	{
		Lin_Reception_of_data=0;

        printf("ID=0x%02X, Read:\r\n",linRxMsg.ID);
        for(u8 i=0; i<8; i++)    printf("%02x ", linRxMsg.Data[i]);
        printf("\r\n");
	}
}

void Lin_SendData_Process(void)//ݵĹ
{
	if(linRxMsg.Receive_Complete)
	{

        printf("ID=0x%02X, Read:\r\n",linRxMsg.Protected_ID);
        for(u8 i=0; i<8; i++)    printf("%02x ", linRxMsg.Data[i]);
        printf("\r\n");

//		u16 checkSum;
//		for(u8 i=0;i<8;i++)
//		{
//			checkSum += linRxMsg.Data[i];       //У
//			if (checkSum >= 256)
//				checkSum = (checkSum+1)&0xff;
//		}
//		checkSum=(u8)~checkSum;
//		linRxMsg.ID=linRxMsg.Protected_ID&0x3f;
//		if(linRxMsg.CheckSum==checkSum)
//		{
//			Lin_Reception_of_data=1;
//			Lin_Data_receiving_callback();
//		}
		linRxMsg.Receive_Complete = DISABLE;
	}
}

void USART2_IRQHandler()
{
	if(USART_GetFlagStatus(USART2,USART_FLAG_LBD)!=RESET)//LIN Breakжϼ־
	{
		if(Lin_Sending_Flag == DISABLE)//ûз
		{
			Lin_LBD_Flag=ENABLE;
		}

        GPIO_ToggleBits(GPIOA,GPIO_Pin_1);  //жжǷ ---> ûв break ж

        USART_ClearFlag(USART2,USART_FLAG_LBD);//LIN Break־
	}
	if(USART_GetFlagStatus(USART2,USART_FLAG_RXNE)!=RESET)//ݼĴΪձ־
	{
//		if(Lin_LBD_Flag==ENABLE)//linжʹܿɽ
		{
			u8 data = USART_ReceiveData(USART2);//

			if(linRxMsg.Index==1)
			{
				linRxMsg.Protected_ID = data;//PID
			}
			else if(linRxMsg.Index>1 && linRxMsg.Index<linRxMsg.Length+2)
			{
				linRxMsg.Data[linRxMsg.Index-2] = data;//				
			}
			else if(linRxMsg.Index == linRxMsg.Length+2)//У鳡
			{
				linRxMsg.CheckSum = data;
			}
			linRxMsg.Index++;
//			if((linRxMsg.Index>linRxMsg.Length+2) && (linRxMsg.Receive_Complete == DISABLE))//ݽ
//			{
//				linRxMsg.Receive_Complete = ENABLE;//ʹ
//				Lin_LBD_Flag = DISABLE;//ʧ
//				Lin_Read_Len = linRxMsg.Index;
//				linRxMsg.Index = 0;
//			}
		}
		USART_ClearFlag(USART2,USART_FLAG_RXNE);//ϣݼĴΪձ־

        if(!(USART2->CR1 & USART_CR1_IDLEIE))
        {
            USART_ITConfig(USART2,USART_IT_IDLE,ENABLE);//ûпIDLEжϵʱٿȻϵȥһ
            USART_ClearFlag(USART2, USART_FLAG_IDLE);
        }
	}
	if(USART_GetFlagStatus(USART2,USART_FLAG_IDLE)!=RESET)//IDLEжϼ־
	{
        if(linRxMsg.Receive_Complete == DISABLE)
        {
            Lin_Read_Len = linRxMsg.Index;
            linRxMsg.Index = 0;
            linRxMsg.Receive_Complete = ENABLE;//ʹ
            Lin_LBD_Flag = DISABLE;//ʧ
        }

        GPIO_ToggleBits(GPIOA,GPIO_Pin_0);  //жжǷ

        USART_ClearFlag(USART2,USART_FLAG_IDLE);//־
        USART_ITConfig(USART2,USART_IT_IDLE,DISABLE);//õʱرմڿжϣֹ
	}
}
